/***************************************************************************
 *            merge_sort3.c
 *
 *  Fri Nov 30 19:24:45 2007
 *  Copyright  2007  pchero21
 *  pchero21@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Node {		// type of strcut Node
    char name[50];
     int number;
} node;

/******************************************************************************/
/*											 Functions 																			*/

/* preform the heapsort */
void heapsort(node *array, int array_size);

/* siftdown */
void siftdown(int pos, node *array, int array_size);

/* swap the each nodes */
void swap_node(node *a, node *b);

/* make random array */
void make_RanArray(int max, node *array);

/* make heap array */
void make_heap(int array_size, node *array);

/******************************************************************************/

int main(void)
{
	
	int i = 0;
	int array_size;					// number of index
	node *array;					// index array

	printf("Insert array index numbers\n");
	printf("Insert : ");
	scanf("%d", &array_size);

	array = (node *)malloc(array_size * sizeof(node));

	make_RanArray(array_size, array);

	/* print the original array */
	printf("\n\nBefore heap_sort\n");
	printf("Name : ");
	for(i = 0; i < array_size; i++)
		printf("%s ", array[i].name);
	putchar('\n');
	printf("Number : ");
	for(i = 0; i < array_size; i++)
		printf("%d ", array[i].number);
	putchar('\n');

	heapsort(array, array_size);

	/* print the `heapsorted' array */
	/* print the original array */
	printf("\n\nAfter_sort\n");
	printf("Name : ");
	for(i = 0; i < array_size; i++)
		printf("%s ", array[i].name);
	putchar('\n');
	printf("Number : ");
	for(i = 0; i < array_size; i++)
		printf("%d ", array[i].number);
	putchar('\n');

	return 0;
}

void heapsort(node *array, int array_size) 
{
	int i = 0;
	node tmp;

	make_heap(array_size, array);

	for(i = array_size - 1; i > 0; i--) {
		tmp = array[0];  
		array[0] = array[i]; 
		array[i] = tmp;
		siftdown(0, array, i);
	}
}
       
void siftdown(int pos, node *array, int array_size)
{
	int parent = 0;
	int largechild = 0; 
	int tmp = 0;
	int left = 0; 
	int right = 0; 

	 parent = pos;
	
	for(;;) {
		left = 2 * parent + 1;  
		right = left + 1;

		if(left >= array_size)
			return;
		else if(right >= array_size)
			largechild = left;
		else if(strcmp(array[left].name, array[right].name) > 0)
			largechild = left; 
		else
			largechild = right; 

		if(strcmp(array[parent].name, array[largechild].name) >0)
			return; 

		swap_node(&array[parent], &array[largechild]);
		parent = largechild;
	}
}

void swap_node(node *a, node *b)
{
	node tmp;

	strcpy(tmp.name, b->name);
	tmp.number = b->number;

	strcpy(b->name, a->name);
	b->number = a->number;

	strcpy(a->name, tmp.name);
	a->number = tmp.number;
}

void make_RanArray(int max, node *array)
{
	int i, tmp_number;
	char char_tmp;

	char_tmp = 'a';

	for(i = 0; i < max; i++) {
		array[i].number = i;

		if(i != 0)
			strcpy(array[i].name, array[i - 1].name);

		array[i].name[i] = char_tmp + i;
		array[i].name[i + 1] = '\0';
	}
	tmp_number = max;
	for(i = 0; i < tmp_number; i++)
		swap_node(&array[rand() % (max - 1)], &array[--tmp_number]);
		
	for(i = 0; i < max; i++)
		array[i].number = i;
}

void make_heap(int array_size, node *array)
{
	int i;

	for(i = array_size / 2; i >= 0; i--)
		siftdown(i, array, array_size);
}
